# Providers

`any-llm` supports multiple providers. Provider source code is in [`src/any_llm/providers/`](https://github.com/mozilla-ai/any-llm/tree/main/src/any_llm/providers).

| ID                                                                                                     | Key                                               | Base                                 | Responses | Completion | <p>Streaming<br>(Completions)</p> | <p>Reasoning<br>(Completions)</p> | <p>Image<br>(Completions)</p> | Embedding | List Models | Batch |
| ------------------------------------------------------------------------------------------------------ | ------------------------------------------------- | ------------------------------------ | --------- | ---------- | --------------------------------- | --------------------------------- | ----------------------------- | --------- | ----------- | ----- |
| [`anthropic`](https://docs.anthropic.com/en/home)                                                      | ANTHROPIC\_API\_KEY                               | ANTHROPIC\_BASE\_URL                 | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ❌         | ✅           | ✅     |
| [`azure`](https://azure.microsoft.com/en-us/products/ai-services/openai-service)                       | AZURE\_API\_KEY                                   | AZURE\_AI\_CHAT\_ENDPOINT            | ❌         | ✅          | ✅                                 | ❌                                 | ❌                             | ✅         | ❌           | ❌     |
| [`azureanthropic`](https://learn.microsoft.com/en-us/azure/ai-foundry/model-inference/concepts/models) | AZURE\_ANTHROPIC\_API\_KEY                        | AZURE\_ANTHROPIC\_API\_BASE          | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ❌         | ❌           | ✅     |
| [`azureopenai`](https://learn.microsoft.com/en-us/azure/ai-foundry/)                                   | AZURE\_OPENAI\_API\_KEY                           | AZURE\_OPENAI\_ENDPOINT              | ✅         | ✅          | ✅                                 | ❌                                 | ✅                             | ✅         | ✅           | ❌     |
| [`bedrock`](https://aws.amazon.com/bedrock/)                                                           | AWS\_BEARER\_TOKEN\_BEDROCK                       | AWS\_ENDPOINT\_URL\_BEDROCK\_RUNTIME | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ✅         | ✅           | ❌     |
| [`cerebras`](https://docs.cerebras.ai/)                                                                | CEREBRAS\_API\_KEY                                | CEREBRAS\_API\_BASE                  | ❌         | ✅          | ✅                                 | ✅                                 | ❌                             | ❌         | ✅           | ❌     |
| [`cohere`](https://cohere.com/api)                                                                     | COHERE\_API\_KEY                                  | COHERE\_BASE\_URL                    | ❌         | ✅          | ✅                                 | ✅                                 | ❌                             | ❌         | ✅           | ❌     |
| [`dashscope`](https://bailian.console.aliyun.com/cn-beijing/?tab=api#/api)                             | DASHSCOPE\_API\_KEY                               | DASHSCOPE\_API\_BASE                 | ❌         | ✅          | ✅                                 | ❌                                 | ✅                             | ✅         | ✅           | ❌     |
| [`databricks`](https://docs.databricks.com/)                                                           | DATABRICKS\_TOKEN                                 | DATABRICKS\_HOST                     | ❌         | ✅          | ✅                                 | ✅                                 | ❌                             | ✅         | ❌           | ❌     |
| [`deepinfra`](https://deepinfra.com/docs/openai_api)                                                   | DEEPINFRA\_API\_KEY                               | DEEPINFRA\_API\_BASE                 | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ✅         | ✅           | ❌     |
| [`deepseek`](https://platform.deepseek.com/)                                                           | DEEPSEEK\_API\_KEY                                | DEEPSEEK\_API\_BASE                  | ❌         | ✅          | ✅                                 | ✅                                 | ❌                             | ❌         | ✅           | ❌     |
| [`fireworks`](https://fireworks.ai/api)                                                                | FIREWORKS\_API\_KEY                               | FIREWORKS\_API\_BASE                 | ✅         | ✅          | ✅                                 | ✅                                 | ✅                             | ❌         | ✅           | ❌     |
| [`gateway`](https://github.com/mozilla-ai/any-llm)                                                     | GATEWAY\_API\_KEY                                 | GATEWAY\_API\_BASE                   | ✅         | ✅          | ✅                                 | ✅                                 | ✅                             | ✅         | ✅           | ✅     |
| [`gemini`](https://ai.google.dev/gemini-api/docs)                                                      | GEMINI\_API\_KEY/GOOGLE\_API\_KEY                 | GOOGLE\_GEMINI\_BASE\_URL            | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ✅         | ✅           | ❌     |
| [`groq`](https://groq.com/api)                                                                         | GROQ\_API\_KEY                                    | GROQ\_BASE\_URL                      | ✅         | ✅          | ✅                                 | ✅                                 | ❌                             | ❌         | ✅           | ❌     |
| [`huggingface`](https://huggingface.co/docs/huggingface_hub/package_reference/inference_client)        | HF\_TOKEN                                         | HUGGINGFACE\_API\_BASE               | ✅         | ✅          | ✅                                 | ❌                                 | ❌                             | ❌         | ✅           | ❌     |
| [`inception`](https://inceptionlabs.ai/)                                                               | INCEPTION\_API\_KEY                               | INCEPTION\_API\_BASE                 | ❌         | ✅          | ✅                                 | ❌                                 | ❌                             | ❌         | ✅           | ❌     |
| [`llama`](https://www.llama.com/products/llama-api/)                                                   | LLAMA\_API\_KEY                                   | LLAMA\_API\_BASE                     | ❌         | ✅          | ✅                                 | ❌                                 | ❌                             | ❌         | ✅           | ❌     |
| [`llamacpp`](https://github.com/ggml-org/llama.cpp)                                                    | None                                              | LLAMACPP\_API\_BASE                  | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ✅         | ✅           | ❌     |
| [`llamafile`](https://github.com/Mozilla-Ocho/llamafile)                                               | None                                              | LLAMAFILE\_API\_BASE                 | ❌         | ✅          | ❌                                 | ✅                                 | ❌                             | ❌         | ✅           | ❌     |
| [`lmstudio`](https://lmstudio.ai/)                                                                     | LM\_STUDIO\_API\_KEY                              | LM\_STUDIO\_API\_BASE                | ✅         | ✅          | ✅                                 | ✅                                 | ✅                             | ✅         | ✅           | ❌     |
| [`minimax`](https://www.minimax.io/platform_overview)                                                  | MINIMAX\_API\_KEY                                 | MINIMAX\_API\_BASE                   | ❌         | ✅          | ✅                                 | ✅                                 | ❌                             | ❌         | ❌           | ❌     |
| [`mistral`](https://docs.mistral.ai/)                                                                  | MISTRAL\_API\_KEY                                 | MISTRAL\_API\_BASE                   | ❌         | ✅          | ✅                                 | ✅                                 | ❌                             | ✅         | ✅           | ✅     |
| [`moonshot`](https://platform.moonshot.ai/)                                                            | MOONSHOT\_API\_KEY                                | MOONSHOT\_API\_BASE                  | ❌         | ✅          | ✅                                 | ✅                                 | ❌                             | ❌         | ✅           | ❌     |
| [`mzai`](https://any-llm.ai)                                                                           | ANY\_LLM\_KEY                                     | ANY\_LLM\_PLATFORM\_URL              | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ✅         | ✅           | ❌     |
| [`nebius`](https://studio.nebius.ai/)                                                                  | NEBIUS\_API\_KEY                                  | NEBIUS\_API\_BASE                    | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ✅         | ✅           | ❌     |
| [`ollama`](https://github.com/ollama/ollama)                                                           | None                                              | OLLAMA\_HOST                         | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ✅         | ✅           | ❌     |
| [`openai`](https://platform.openai.com/docs/api-reference)                                             | OPENAI\_API\_KEY                                  | OPENAI\_BASE\_URL                    | ✅         | ✅          | ✅                                 | ❌                                 | ✅                             | ✅         | ✅           | ✅     |
| [`openrouter`](https://openrouter.ai/docs)                                                             | OPENROUTER\_API\_KEY                              | OPENROUTER\_API\_BASE                | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ✅         | ✅           | ❌     |
| [`perplexity`](https://docs.perplexity.ai/)                                                            | PERPLEXITY\_API\_KEY                              | PERPLEXITY\_BASE\_URL                | ❌         | ✅          | ✅                                 | ❌                                 | ✅                             | ❌         | ❌           | ❌     |
| [`portkey`](https://portkey.ai/docs)                                                                   | PORTKEY\_API\_KEY                                 | PORTKEY\_API\_BASE                   | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ❌         | ✅           | ❌     |
| [`sagemaker`](https://aws.amazon.com/sagemaker/)                                                       | AWS\_ACCESS\_KEY\_ID and AWS\_SECRET\_ACCESS\_KEY | SAGEMAKER\_ENDPOINT\_URL             | ❌         | ✅          | ✅                                 | ❌                                 | ✅                             | ✅         | ❌           | ❌     |
| [`sambanova`](https://sambanova.ai/)                                                                   | SAMBANOVA\_API\_KEY                               | SAMBANOVA\_API\_BASE                 | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ✅         | ✅           | ❌     |
| [`together`](https://together.ai/)                                                                     | TOGETHER\_API\_KEY                                | TOGETHER\_API\_BASE                  | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ❌         | ❌           | ❌     |
| [`vertexai`](https://cloud.google.com/vertex-ai/docs)                                                  |                                                   | VERTEXAI\_API\_BASE                  | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ✅         | ✅           | ❌     |
| [`vertexaianthropic`](https://cloud.google.com/vertex-ai/generative-ai/docs/partner-models/use-claude) |                                                   | VERTEXAI\_ANTHROPIC\_API\_BASE       | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ❌         | ❌           | ✅     |
| [`vllm`](https://docs.vllm.ai/)                                                                        | VLLM\_API\_KEY                                    | VLLM\_API\_BASE                      | ❌         | ✅          | ✅                                 | ✅                                 | ✅                             | ✅         | ✅           | ❌     |
| [`voyage`](https://docs.voyageai.com/)                                                                 | VOYAGE\_API\_KEY                                  | VOYAGE\_API\_BASE                    | ❌         | ❌          | ❌                                 | ❌                                 | ❌                             | ✅         | ❌           | ❌     |
| [`watsonx`](https://www.ibm.com/watsonx)                                                               | WATSONX\_API\_KEY                                 | WATSONX\_URL                         | ❌         | ✅          | ✅                                 | ❌                                 | ✅                             | ❌         | ✅           | ❌     |
| [`xai`](https://x.ai/)                                                                                 | XAI\_API\_KEY                                     | XAI\_API\_BASE                       | ❌         | ✅          | ✅                                 | ✅                                 | ❌                             | ❌         | ✅           | ❌     |
| [`zai`](https://docs.z.ai/guides/develop/python/introduction)                                          | ZAI\_API\_KEY                                     | ZAI\_BASE\_URL                       | ❌         | ✅          | ✅                                 | ✅                                 | ❌                             | ❌         | ✅           | ❌     |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.mozilla.ai/providers.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
